<template>
  <div class="login__content-wrapper">
    <page-title>Entre com a sua conta</page-title>
    <separator>Faça login com as redes sociais</separator>
    <social />
    <separator>Ou utilize os campos abaixo</separator>
    <a-form :form="form" class="login__form" @submit.prevent="signIn">
      <a-form-item class="login__form-item" label="E-mail">
        <a-input
          v-decorator="[
            'email',
            {
              rules: [
                { required: true, message: 'Por favor seu email' },
                { type: 'email', message: 'Por favor digite um email válido' }
              ]
            }
          ]"
          type="email"
          class="login__form-input"
          auto-focus
        />
      </a-form-item>

      <a-form-item class="login__form-item" label="Senha">
        <p
          v-if="false"
          type="link"
          style="position: absolute; right: 0; top: -50px; z-index: 2; cursor: pointer"
        >
          Esqueci a senha
        </p>
        <a-input
          v-decorator="[
            'password',
            {
              rules: [{ required: true, message: 'Por favor sua senha' }]
            }
          ]"
          type="password"
          class="login__form-input"
        />
      </a-form-item>

      <separator terms>
        Ao fazer login, você concorda com os
        <nuxt-link to="/">Termos de licença de uso</nuxt-link>.
      </separator>

      <submit-button>
        Fazer login
      </submit-button>
    </a-form>
  </div>
</template>

<script>
import { mapActions } from 'vuex'
import { auth } from '~/firebase'

import Title from '~/components/Auth/Title.vue'
import Separator from '~/components/Auth/Separator.vue'
import Social from '~/components/Auth/Social.vue'
import Button from '~/components/Auth/Button.vue'

export default {
  components: {
    'page-title': Title,
    'submit-button': Button,
    Separator,
    Social
  },
  middleware: 'auth',
  data() {
    return {
      form: this.$form.createForm(this)
    }
  },
  head() {
    return {
      title: 'Acolher.me - Login'
    }
  },
  layout: 'auth',
  transition: {
    enterActiveClass: 'animated slideInLeft',
    leaveActiveClass: 'animated fadeOutLeft'
  },
  methods: {
    ...mapActions('user', ['login']),
    signIn() {
      this.form.validateFieldsAndScroll(async (err, values) => {
        if (!err) {
          try {
            await auth.signInWithEmailAndPassword(values.email, values.password)
            const user = await auth.currentUser
            const token = await user.getIdToken(true)
            const { uid, email, photoURL, displayName, emailVerified } = user

            await this.login({
              uid,
              email,
              photoURL,
              displayName,
              token,
              isVerified: emailVerified
            })

            if (emailVerified) {
              this.$router.push({ path: '/admin' })
            } else {
              this.$router.push({ path: '/auth/email-verification' })
            }
          } catch (error) {
            console.log(error)
          }
        }
      })
    }
  }
}
</script>

<style lang="less" scoped>
.login {
  &__form {
    display: flex;
    flex-direction: column;
    align-items: center;
    width: 100%;

    @media screen and (min-width: 768px) {
      max-width: 500px;
    }

    &-item {
      width: 100%;
      position: relative;
    }
  }

  &__content {
    &-wrapper {
      width: 100%;
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
    }

    &-title {
      font-size: 30px;
      line-height: 50px;
      color: #202121;
      text-align: center;
      margin: 0 0 10px;
      font-weight: bold;
    }

    &-separator {
      font-size: 16px;
      text-align: center;
      opacity: 0.8;
    }

    &-social {
      &-wrapper {
        display: flex;
        flex-direction: row;
        align-items: center;
        justify-content: center;
        margin-bottom: 15px;
      }

      &__button {
        margin: 10px;
      }
    }
  }
}

.google {
  background-color: #df4d3b;
}

.facebook {
  background-color: #47546d;
}

.terms {
  margin-top: 0;
  margin-bottom: 0;
  font-size: 1.4rem;
}
</style>
